refs #8558
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/arv-git-httpd
63 services/crunchstat
64 services/dockercleaner
65 services/fuse
66 services/keep-web
67 services/keepproxy
68 services/keepstore
69 services/login-sync
70 services/nodemanager
71 services/crunch-dispatch-local
72 sdk/cli
73 sdk/pam
74 sdk/python
75 sdk/ruby
76 sdk/go/arvadosclient
77 sdk/go/keepclient
78 sdk/go/manifest
79 sdk/go/blockdigest
80 sdk/go/streamer
81 sdk/go/crunchrunner
82 sdk/cwl
83 tools/crunchstat-summary
84 tools/keep-rsync
85
86 EOF
87
88 # First make sure to remove any ARVADOS_ variables from the calling
89 # environment that could interfere with the tests.
90 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
91
92 # Reset other variables that could affect our [tests'] behavior by
93 # accident.
94 GITDIR=
95 GOPATH=
96 VENVDIR=
97 VENV3DIR=
98 PYTHONPATH=
99 GEMHOME=
100 PERLINSTALLBASE=
101
102 COLUMNS=80
103
104 skip_install=
105 temp=
106 temp_preserve=
107
108 clear_temp() {
109     if [[ -z "$temp" ]]; then
110         # we didn't even get as far as making a temp dir
111         :
112     elif [[ -z "$temp_preserve" ]]; then
113         rm -rf "$temp"
114     else
115         echo "Leaving behind temp dirs in $temp"
116     fi
117 }
118
119 fatal() {
120     clear_temp
121     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
122     exit 1
123 }
124
125 report_outcomes() {
126     for x in "${successes[@]}"
127     do
128         echo "Pass: $x"
129     done
130
131     if [[ ${#failures[@]} == 0 ]]
132     then
133         echo "All test suites passed."
134     else
135         echo "Failures (${#failures[@]}):"
136         for x in "${failures[@]}"
137         do
138             echo "Fail: $x"
139         done
140     fi
141 }
142
143 exit_cleanly() {
144     trap - INT
145     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
146     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
147     stop_services
148     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
149     report_outcomes
150     clear_temp
151     exit ${#failures}
152 }
153
154 sanity_checks() {
155     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
156         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
157     echo Checking dependencies:
158     echo -n 'virtualenv: '
159     virtualenv --version \
160         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
161     echo -n 'go: '
162     go version \
163         || fatal "No go binary. See http://golang.org/doc/install"
164     echo -n 'gcc: '
165     gcc --version | egrep ^gcc \
166         || fatal "No gcc. Try: apt-get install build-essential"
167     echo -n 'fuse.h: '
168     find /usr/include -wholename '*fuse/fuse.h' \
169         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
170     echo -n 'pyconfig.h: '
171     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
172         || fatal "No pyconfig.h. Try: apt-get install python-dev"
173     echo -n 'nginx: '
174     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
175         || fatal "No nginx. Try: apt-get install nginx"
176     echo -n 'perl: '
177     perl -v | grep version \
178         || fatal "No perl. Try: apt-get install perl"
179     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
180         echo -n "perl $mod: "
181         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
182             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
183     done
184     echo -n 'gitolite: '
185     which gitolite \
186         || fatal "No gitolite. Try: apt-get install gitolite3"
187 }
188
189 rotate_logfile() {
190   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
191   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
192   if [[ -f "$1/$2" ]]; then
193     THEDATE=`date +%Y%m%d%H%M%S`
194     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
195     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
196   fi
197 }
198
199 declare -a failures
200 declare -A skip
201 declare -A testargs
202 skip[apps/workbench_profile]=1
203
204 while [[ -n "$1" ]]
205 do
206     arg="$1"; shift
207     case "$arg" in
208         --help)
209             echo >&2 "$helpmessage"
210             echo >&2
211             exit 1
212             ;;
213         --skip)
214             skipwhat="$1"; shift
215             skip[$skipwhat]=1
216             ;;
217         --only)
218             only="$1"; skip[$1]=""; shift
219             ;;
220         --skip-install)
221             skip_install=1
222             ;;
223         --only-install)
224             skip_install=1
225             only_install="$1"; shift
226             ;;
227         --temp)
228             temp="$1"; shift
229             temp_preserve=1
230             ;;
231         --leave-temp)
232             temp_preserve=1
233             ;;
234         --retry)
235             retry=1
236             ;;
237         *_test=*)
238             suite="${arg%%_test=*}"
239             args="${arg#*=}"
240             testargs["$suite"]="$args"
241             ;;
242         *=*)
243             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
244             ;;
245         *)
246             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
247             exit 1
248             ;;
249     esac
250 done
251
252 start_api() {
253     echo 'Starting API server...'
254     cd "$WORKSPACE" \
255         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
256         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
257         && export ARVADOS_TEST_API_INSTALLED="$$" \
258         && (env | egrep ^ARVADOS)
259 }
260
261 start_nginx_proxy_services() {
262     echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
263     cd "$WORKSPACE" \
264         && python sdk/python/tests/run_test_server.py start_keep_proxy \
265         && python sdk/python/tests/run_test_server.py start_keep-web \
266         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
267         && python sdk/python/tests/run_test_server.py start_nginx \
268         && export ARVADOS_TEST_PROXY_SERVICES=1
269 }
270
271 stop_services() {
272     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
273         unset ARVADOS_TEST_PROXY_SERVICES
274         cd "$WORKSPACE" \
275             && python sdk/python/tests/run_test_server.py stop_nginx \
276             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
277             && python sdk/python/tests/run_test_server.py stop_keep-web \
278             && python sdk/python/tests/run_test_server.py stop_keep_proxy
279     fi
280     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
281         unset ARVADOS_TEST_API_HOST
282         cd "$WORKSPACE" \
283             && python sdk/python/tests/run_test_server.py stop
284     fi
285 }
286
287 interrupt() {
288     failures+=("($(basename $0) interrupted)")
289     exit_cleanly
290 }
291 trap interrupt INT
292
293 sanity_checks
294
295 echo "WORKSPACE=$WORKSPACE"
296
297 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
298     # Jenkins expects us to use this by default.
299     CONFIGSRC="$HOME/arvados-api-server"
300 fi
301
302 # Clean up .pyc files that may exist in the workspace
303 cd "$WORKSPACE"
304 find -name '*.pyc' -delete
305
306 if [[ -z "$temp" ]]; then
307     temp="$(mktemp -d)"
308 fi
309
310 # Set up temporary install dirs (unless existing dirs were supplied)
311 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
312 do
313     if [[ -z "${!tmpdir}" ]]; then
314         eval "$tmpdir"="$temp/$tmpdir"
315     fi
316     if ! [[ -d "${!tmpdir}" ]]; then
317         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
318     fi
319 done
320
321 setup_ruby_environment() {
322     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
323       source "$HOME/.rvm/scripts/rvm"
324       using_rvm=true
325     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
326       source "/usr/local/rvm/scripts/rvm"
327       using_rvm=true
328     else
329       using_rvm=false
330     fi
331
332     if [[ "$using_rvm" == true ]]; then
333         # If rvm is in use, we can't just put separate "dependencies"
334         # and "gems-under-test" paths to GEM_PATH: passenger resets
335         # the environment to the "current gemset", which would lose
336         # our GEM_PATH and prevent our test suites from running ruby
337         # programs (for example, the Workbench test suite could not
338         # boot an API server or run arv). Instead, we have to make an
339         # rvm gemset and use it for everything.
340
341         [[ `type rvm | head -n1` == "rvm is a function" ]] \
342             || fatal 'rvm check'
343
344         # Put rvm's favorite path back in first place (overriding
345         # virtualenv, which just put itself there). Ignore rvm's
346         # complaint about not being in first place already.
347         rvm use @default 2>/dev/null
348
349         # Create (if needed) and switch to an @arvados-tests
350         # gemset. (Leave the choice of ruby to the caller.)
351         rvm use @arvados-tests --create \
352             || fatal 'rvm gemset setup'
353
354         rvm env
355     else
356         # When our "bundle install"s need to install new gems to
357         # satisfy dependencies, we want them to go where "gem install
358         # --user-install" would put them. (However, if the caller has
359         # already set GEM_HOME, we assume that's where dependencies
360         # should be installed, and we should leave it alone.)
361
362         if [ -z "$GEM_HOME" ]; then
363             user_gempath="$(gem env gempath)"
364             export GEM_HOME="${user_gempath%%:*}"
365         fi
366         PATH="$(gem env gemdir)/bin:$PATH"
367
368         # When we build and install our own gems, we install them in our
369         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
370         # PATH so integration tests prefer them over other versions that
371         # happen to be installed in $user_gempath, system dirs, etc.
372
373         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
374         PATH="$tmpdir_gem_home/bin:$PATH"
375         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
376
377         echo "Will install dependencies to $(gem env gemdir)"
378         echo "Will install arvados gems to $tmpdir_gem_home"
379         echo "Gem search path is GEM_PATH=$GEM_PATH"
380     fi
381 }
382
383 with_test_gemset() {
384     if [[ "$using_rvm" == true ]]; then
385         "$@"
386     else
387         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
388     fi
389 }
390
391 gem_uninstall_if_exists() {
392     if gem list "$1\$" | egrep '^\w'; then
393         gem uninstall --force --all --executables "$1"
394     fi
395 }
396
397 setup_virtualenv() {
398     local venvdest="$1"; shift
399     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
400         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
401     fi
402     "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
403     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
404     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
405 }
406
407 export PERLINSTALLBASE
408 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
409
410 export GOPATH
411 mkdir -p "$GOPATH/src/git.curoverse.com"
412 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
413     || fatal "symlink failed"
414
415 setup_virtualenv "$VENVDIR" --python python2.7
416 . "$VENVDIR/bin/activate"
417
418 # Needed for run_test_server.py which is used by certain (non-Python) tests.
419 pip freeze 2>/dev/null | egrep ^PyYAML= \
420     || pip install PyYAML >/dev/null \
421     || fatal "pip install PyYAML failed"
422
423 # Preinstall forked version of libcloud, because nodemanager "pip install"
424 # won't pick it up by default.
425 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
426     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
427     || fatal "pip install apache-libcloud failed"
428
429 # Deactivate Python 2 virtualenv
430 deactivate
431
432 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
433 # Otherwise, skip dependent tests.
434 PYTHON3=$(which python3)
435 if [ "0" = "$?" ]; then
436     setup_virtualenv "$VENV3DIR" --python python3
437 else
438     PYTHON3=
439     skip[services/dockercleaner]=1
440     cat >&2 <<EOF
441
442 Warning: python3 could not be found
443 services/dockercleaner install and tests will be skipped
444
445 EOF
446 fi
447
448 # Reactivate Python 2 virtualenv
449 . "$VENVDIR/bin/activate"
450
451 # Note: this must be the last time we change PATH, otherwise rvm will
452 # whine a lot.
453 setup_ruby_environment
454
455 echo "PATH is $PATH"
456
457 if ! which bundler >/dev/null
458 then
459     gem install --user-install bundler || fatal 'Could not install bundler'
460 fi
461
462 checkexit() {
463     if [[ "$1" != "0" ]]; then
464         title "!!!!!! $2 FAILED !!!!!!"
465         failures+=("$2 (`timer`)")
466     else
467         successes+=("$2 (`timer`)")
468     fi
469 }
470
471 timer_reset() {
472     t0=$SECONDS
473 }
474
475 timer() {
476     echo -n "$(($SECONDS - $t0))s"
477 }
478
479 do_test() {
480     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
481     do
482         read -p 'Try again? [Y/n] ' x
483         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
484         then
485             break
486         fi
487     done
488 }
489
490 do_test_once() {
491     unset result
492     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
493     then
494         title "Running $1 tests"
495         timer_reset
496         if [[ "$2" == "go" ]]
497         then
498             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
499             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
500             # We do "go get -t" here to catch compilation errors
501             # before trying "go test". Otherwise, coverage-reporting
502             # mode makes Go show the wrong line numbers when reporting
503             # compilation errors.
504             if [[ -n "${testargs[$1]}" ]]
505             then
506                 # "go test -check.vv giturl" doesn't work, but this
507                 # does:
508                 cd "$WORKSPACE/$1" && \
509                     go get -t "git.curoverse.com/arvados.git/$1" && \
510                     go test ${coverflags[@]} ${testargs[$1]}
511             else
512                 # The above form gets verbose even when testargs is
513                 # empty, so use this form in such cases:
514                 go get -t "git.curoverse.com/arvados.git/$1" && \
515                     go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
516             fi
517             result="$?"
518             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
519             rm "$WORKSPACE/tmp/.$covername.tmp"
520         elif [[ "$2" == "pip" ]]
521         then
522             # $3 can name a path directory for us to use, including trailing
523             # slash; e.g., the bin/ subdirectory of a virtualenv.
524             cd "$WORKSPACE/$1" \
525                 && "${3}python" setup.py test ${testargs[$1]}
526         elif [[ "$2" != "" ]]
527         then
528             "test_$2"
529         else
530             "test_$1"
531         fi
532         result=${result:-$?}
533         checkexit $result "$1 tests"
534         title "End of $1 tests (`timer`)"
535         return $result
536     else
537         title "Skipping $1 tests"
538     fi
539 }
540
541 do_install() {
542     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
543     then
544         title "Running $1 install"
545         timer_reset
546         if [[ "$2" == "go" ]]
547         then
548             go get -t "git.curoverse.com/arvados.git/$1"
549         elif [[ "$2" == "pip" ]]
550         then
551             # $3 can name a path directory for us to use, including trailing
552             # slash; e.g., the bin/ subdirectory of a virtualenv.
553
554             # Need to change to a different directory after creating
555             # the source dist package to avoid a pip bug.
556             # see https://arvados.org/issues/5766 for details.
557
558             # Also need to install twice, because if it believes the package is
559             # already installed, pip it won't install it.  So the first "pip
560             # install" ensures that the dependencies are met, the second "pip
561             # install" ensures that we've actually installed the local package
562             # we just built.
563             cd "$WORKSPACE/$1" \
564                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
565                 && cd "$WORKSPACE" \
566                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
567                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
568         elif [[ "$2" != "" ]]
569         then
570             "install_$2"
571         else
572             "install_$1"
573         fi
574         checkexit $? "$1 install"
575         title "End of $1 install (`timer`)"
576     else
577         title "Skipping $1 install"
578     fi
579 }
580
581 title () {
582     txt="********** $1 **********"
583     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
584 }
585
586 bundle_install_trylocal() {
587     (
588         set -e
589         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
590         if ! bundle install --local --no-deployment; then
591             echo "(Running bundle install again, without --local.)"
592             bundle install --no-deployment
593         fi
594         bundle package --all
595     )
596 }
597
598 install_doc() {
599     cd "$WORKSPACE/doc" \
600         && bundle_install_trylocal \
601         && rm -rf .site
602 }
603 do_install doc
604
605 install_gem() {
606     gemname=$1
607     srcpath=$2
608     with_test_gemset gem_uninstall_if_exists "$gemname" \
609         && cd "$WORKSPACE/$srcpath" \
610         && bundle_install_trylocal \
611         && gem build "$gemname.gemspec" \
612         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
613 }
614
615 install_ruby_sdk() {
616     install_gem arvados sdk/ruby
617 }
618 do_install sdk/ruby ruby_sdk
619
620 install_perl_sdk() {
621     cd "$WORKSPACE/sdk/perl" \
622         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
623         && make install INSTALLDIRS=perl
624 }
625 do_install sdk/perl perl_sdk
626
627 install_cli() {
628     install_gem arvados-cli sdk/cli
629 }
630 do_install sdk/cli cli
631
632 install_login-sync() {
633     install_gem arvados-login-sync services/login-sync
634 }
635 do_install services/login-sync login-sync
636
637 # Install the Python SDK early. Various other test suites (like
638 # keepproxy) bring up run_test_server.py, which imports the arvados
639 # module. We can't actually *test* the Python SDK yet though, because
640 # its own test suite brings up some of those other programs (like
641 # keepproxy).
642 declare -a pythonstuff
643 pythonstuff=(
644     sdk/pam
645     sdk/python
646     sdk/cwl
647     services/fuse
648     services/nodemanager
649     tools/crunchstat-summary
650     )
651 for p in "${pythonstuff[@]}"
652 do
653     do_install "$p" pip
654 done
655 if [ -n "$PYTHON3" ]; then
656     do_install services/dockercleaner pip "$VENV3DIR/bin/"
657 fi
658
659 install_apiserver() {
660     cd "$WORKSPACE/services/api" \
661         && RAILS_ENV=test bundle_install_trylocal
662
663     rm -f config/environments/test.rb
664     cp config/environments/test.rb.example config/environments/test.rb
665
666     if [ -n "$CONFIGSRC" ]
667     then
668         for f in database.yml application.yml
669         do
670             cp "$CONFIGSRC/$f" config/ || fatal "$f"
671         done
672     fi
673
674     # Fill in a random secret_token and blob_signing_key for testing
675     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
676     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
677
678     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
679     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
680
681     # Set up empty git repo (for git tests)
682     GITDIR=$(mktemp -d)
683     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
684
685     rm -rf $GITDIR
686     mkdir -p $GITDIR/test
687     cd $GITDIR/test \
688         && git init \
689         && git config user.email "jenkins@ci.curoverse.com" \
690         && git config user.name "Jenkins, CI" \
691         && touch tmp \
692         && git add tmp \
693         && git commit -m 'initial commit'
694
695     # Clear out any lingering postgresql connections to the test
696     # database, so that we can drop it. This assumes the current user
697     # is a postgresql superuser.
698     cd "$WORKSPACE/services/api" \
699         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
700         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
701
702     cd "$WORKSPACE/services/api" \
703         && RAILS_ENV=test bundle exec rake db:drop \
704         && RAILS_ENV=test bundle exec rake db:setup \
705         && RAILS_ENV=test bundle exec rake db:fixtures:load
706 }
707 do_install services/api apiserver
708
709 declare -a gostuff
710 gostuff=(
711     sdk/go/arvadosclient
712     sdk/go/blockdigest
713     sdk/go/manifest
714     sdk/go/streamer
715     sdk/go/crunchrunner
716     services/arv-git-httpd
717     services/crunchstat
718     services/keep-web
719     services/keepstore
720     sdk/go/keepclient
721     services/keepproxy
722     services/datamanager/summary
723     services/datamanager/collection
724     services/datamanager/keep
725     services/datamanager
726     services/crunch-dispatch-local
727     services/crunch-run
728     tools/keep-rsync
729     )
730 for g in "${gostuff[@]}"
731 do
732     do_install "$g" go
733 done
734
735 install_workbench() {
736     cd "$WORKSPACE/apps/workbench" \
737         && mkdir -p tmp/cache \
738         && RAILS_ENV=test bundle_install_trylocal
739 }
740 do_install apps/workbench workbench
741
742 test_doclinkchecker() {
743     (
744         set -e
745         cd "$WORKSPACE/doc"
746         ARVADOS_API_HOST=qr1hi.arvadosapi.com
747         # Make sure python-epydoc is installed or the next line won't
748         # do much good!
749         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
750     )
751 }
752 do_test doc doclinkchecker
753
754 stop_services
755
756 test_apiserver() {
757     cd "$WORKSPACE/services/api" \
758         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
759 }
760 do_test services/api apiserver
761
762 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
763 # because we don't need to start up the api server for subsequent tests.
764 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
765   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
766   exit_cleanly
767 fi
768
769 start_api
770
771 test_ruby_sdk() {
772     cd "$WORKSPACE/sdk/ruby" \
773         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
774 }
775 do_test sdk/ruby ruby_sdk
776
777 test_cli() {
778     cd "$WORKSPACE/sdk/cli" \
779         && mkdir -p /tmp/keep \
780         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
781 }
782 do_test sdk/cli cli
783
784 test_login-sync() {
785     cd "$WORKSPACE/services/login-sync" \
786         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
787 }
788 do_test services/login-sync login-sync
789
790 for p in "${pythonstuff[@]}"
791 do
792     do_test "$p" pip
793 done
794 do_test services/dockercleaner pip "$VENV3DIR/bin/"
795
796 for g in "${gostuff[@]}"
797 do
798     do_test "$g" go
799 done
800
801 test_workbench() {
802     start_nginx_proxy_services \
803         && cd "$WORKSPACE/apps/workbench" \
804         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
805 }
806 do_test apps/workbench workbench
807
808 test_workbench_benchmark() {
809     start_nginx_proxy_services \
810         && cd "$WORKSPACE/apps/workbench" \
811         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
812 }
813 do_test apps/workbench_benchmark workbench_benchmark
814
815 test_workbench_profile() {
816     start_nginx_proxy_services \
817         && cd "$WORKSPACE/apps/workbench" \
818         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
819 }
820 do_test apps/workbench_profile workbench_profile
821
822 exit_cleanly